=== debian/changelog ===
websocketd (0.3.1-3) unstable; urgency=medium

  * Add salsa-ci configuration file
  * Switch from golang-websocket-dev to golang-github-gorilla-websocket-dev
  * Bump Standards-Version to 4.4.1. No changes required

 -- Josue Ortega <josue@debian.org>  Sun, 10 Nov 2019 12:54:07 -0600

websocketd (0.3.1-2) unstable; urgency=medium

  * debian/control: Fix VCS URLs.
  * Update package to use debhelper-compat (= 12)
  * Bump Standards-Version to 4.4.0. No changes required

 -- Josue Ortega <josue@debian.org>  Sun, 11 Aug 2019 17:47:26 -0600

websocketd (0.3.1-1) unstable; urgency=medium

  * Initial release (Closes: #920520)

 -- Josue Ortega <josue@debian.org>  Sun, 10 Feb 2019 12:02:59 -0600
