=== debian/control ===
Source: websocketd
Section: web
Priority: optional
Maintainer: Josue Ortega <josue@debian.org>
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               golang-any,
               golang-github-gorilla-websocket-dev
Standards-Version: 4.4.1
Homepage: https://github.com/joewalnes/websocketd
Vcs-Browser: https://salsa.debian.org/debian/websocketd
Vcs-Git: https://salsa.debian.org/debian/websocketd.git
XS-Go-Import-Path: github.com/joewalnes/websocketd
Testsuite: autopkgtest-pkg-go
Rules-Requires-Root: no

Package: websocketd
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Turn any program that uses STDIN/STDOUT into a WebSocket server
 websocketd is a small command-line tool that will wrap an existing
 command-line interface program, and allow it to be accessed
 via a WebSocket.
 .
 WebSocket-capable applications can now be built very easily. As long as
 you can write an executable program that reads STDIN and writes to STDOUT,
 you can build a WebSocket server. Do it in Python, Ruby, Perl, Bash,
 C, Go, PHP, Java, Clojure, Scala, Groovy, Expect, Awk, VBScript,
 Haskell, Lua, R, whatever! No networking libraries necessary.
 .
 websocketd will start a WebSocket server on a specified port, and listen
 for connections.
 .
 Upon a connection, it will fork the appropriate process, and disconnect
 the process when the WebSocket connection closes (and vice-versa).
 .
 Any message sent from the WebSocket client will be piped to the process's
 STDIN stream, followed by a \n newline.
