=== debian/tests/control ===
Test-Command: websocketd --version
