## websocketd 0.4.1

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	mkdir -p $(GO_DIR)
 	rm -f $@
 	@echo Downloading and unpacking Go $(GO_VERSION) to $(GO_DIR)
-	curl -s $(GO_DOWNLOAD_URL) | tar xf - --strip-components=1 -C $(GO_DIR)
+	curl -s $(GO_DOWNLOAD_URL) | tar xfz - --strip-components=1 -C $(GO_DIR)
 
 # Clean up binary
 clean:
