=== release/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 # Uses Semantic Versioning scheme - http://semver.org/
 VERSION_MAJOR=0
-VERSION_MINOR=3
+VERSION_MINOR=4
 
 # Last part of version number (patch) is incremented automatically from Git tags
 LAST_PATCH_VERSION:=$(shell git ls-remote git@github.com:joewalnes/websocketd.git \
@@ -18,10 +18,10 @@
 
 
 
-VERSION_PATCH:=$(shell expr $$(( $(or $(LAST_PATCH_VERSION),-1) + 1 )))
+VERSION_PATCH:=$(or $(LAST_PATCH_VERSION),0)
 RELEASE_VERSION=$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)
 
-GO_VERSION=1.11.5
+GO_VERSION=1.15.7
 PLATFORMS=linux_amd64 linux_386 linux_arm linux_arm64 darwin_amd64 freebsd_amd64 freebsd_386 windows_386 windows_amd64 openbsd_386 openbsd_amd64 solaris_amd64
