=== debian/changelog ===
websocketd (0.4.1-1) unstable; urgency=medium

  * New upstream release (0.4.1-1)
  * Update packate to use debhelper-compat (= 13)
  * Bump Standards Version to 4.5.1. No changes required
  * Mark autopkgtest as superficial

 -- Josue Ortega <josue@debian.org>  Sun, 31 Jan 2021 13:09:55 -0600
