=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: web
 Priority: optional
 Maintainer: Josue Ortega <josue@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
                golang-github-gorilla-websocket-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Homepage: https://github.com/joewalnes/websocketd
 Vcs-Browser: https://salsa.debian.org/debian/websocketd
 Vcs-Git: https://salsa.debian.org/debian/websocketd.git
