=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_install:
	/bin/rm -rf examples/f#/\.gitignore
	/bin/rm -rf examples/c#/\.gitignore
	dh_auto_install -- --no-source

%:
	dh $@ --buildsystem=golang --with=golang
